package com.repair.controller;


import com.repair.api.RepairRefundRecordControllerAPI;
import com.repair.common.utils.paramUtils;
import com.repair.model.pojo.RepairRefundRecord;
import com.repair.model.result.CommonResult;
import com.repair.model.result.PageUtils;
import com.repair.services.RepairRefundRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-07-20
 */
@RestController
public class RepairRefundRecordController implements RepairRefundRecordControllerAPI {

    @Autowired
    private RepairRefundRecordService repairRefundRecordService;

    /**
     * 新增退款记录
     * @param rc 退款记录数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult insertRepairRefundRecord(RepairRefundRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairRefundRecordService.insertRepairRefundRecord(rc);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新退款记录
     * @param rc 退款记录
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult updateRepairRefundRecordById(RepairRefundRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairRefundRecordService.updateRepairRefundRecord(rc);

        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 退款记录分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageRepairRefundRecords(int currentPage, int pageCount, String name) {
        PageUtils<RepairRefundRecord> result = repairRefundRecordService.queryPageRepairRefundRecords(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }

    /**
     * 根据数据ID删除退款记录
     * @param id 数据ID
     * @return
     */
    @Override
    public CommonResult deleteRepairRefundRecordById(int id) {
        RepairRefundRecord data = repairRefundRecordService.getRepairById(id);
        if (data == null) {
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = repairRefundRecordService.deleteRepairRefundRecordById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

